/* Copyright (c) 1997-2004
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#include<Array.h>

namespace polymake
{
   /* Fibonacci numbers */
   class Fibonacci
   {
      private:
	 Array<int> numbers;
	 
      public:
	 Fibonacci(const int m=0) : numbers(m)
	 {
	    if (m>=1)
	    {
	       numbers[0]=1;
	       if (m>=2)
	       {
		  numbers[1]=1;
		  for (int i=2; i<m; ++i)
		     numbers[i] = numbers[i-2] + numbers[i-1];
	       }
	    }
	 }
	 
	 int number(const int k) const { return numbers[k]; }
   };

}
